package com.gxwebsoft.house.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.house.service.InfoService;
import com.gxwebsoft.house.entity.Info;
import com.gxwebsoft.house.param.InfoParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 房源信息表控制器
 *
 * @author 科技小王子
 * @since 2023-08-03 18:23:43
 */
@Api(tags = "房源信息表管理")
@RestController
@RequestMapping("/api/house/info")
public class InfoController extends BaseController {
    @Resource
    private InfoService infoService;

    @PreAuthorize("hasAuthority('house:info:list')")
    @OperationLog
    @ApiOperation("分页查询房源信息表")
    @GetMapping("/page")
    public ApiResult<PageResult<Info>> page(InfoParam param) {
        // 使用关联查询
        return success(infoService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('house:info:list')")
    @OperationLog
    @ApiOperation("查询全部房源信息表")
    @GetMapping()
    public ApiResult<List<Info>> list(InfoParam param) {
        // 使用关联查询
        return success(infoService.listRel(param));
    }

    @PreAuthorize("hasAuthority('house:info:list')")
    @OperationLog
    @ApiOperation("根据id查询房源信息表")
    @GetMapping("/{id}")
    public ApiResult<Info> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(infoService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('house:info:save')")
    @OperationLog
    @ApiOperation("添加房源信息表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Info info) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          info.setUserId(loginUser.getUserId());
        }
        if (infoService.save(info)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('house:info:update')")
    @OperationLog
    @ApiOperation("修改房源信息表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Info info) {
        if (infoService.updateById(info)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('house:info:remove')")
    @OperationLog
    @ApiOperation("删除房源信息表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (infoService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('house:info:save')")
    @OperationLog
    @ApiOperation("批量添加房源信息表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Info> list) {
        if (infoService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('house:info:update')")
    @OperationLog
    @ApiOperation("批量修改房源信息表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Info> batchParam) {
        if (batchParam.update(infoService, "house_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('house:info:remove')")
    @OperationLog
    @ApiOperation("批量删除房源信息表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (infoService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
